package cn.com.ctop.common.module.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 用户分配
 * @author jeecg-boot
 * @date 2019-08-08
 * @version V1.0
 */
@Data
@TableName("ctop_user_allocation")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_user_allocation对象", description = "用户分配")
public class UserAllocation {

    /**
     * 主键ID
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键ID")
    private Long id;
    /**
     * 登陆人id
     */
    @Excel(name = "登陆人id", width = 15)
    @ApiModelProperty(value = "登陆人id")
    private String userId;
    /**
     * 账户id --授权
     */
    @Excel(name = "账户id --授权", width = 15)
    @ApiModelProperty(value = "账户id --授权")
    private Long accountId;
    /**
     * 广告主ID
     */
    @Excel(name = "广告主ID", width = 15)
    @ApiModelProperty(value = "广告主ID")
    private String advertiserId;
    /**
     * 指定分配人
     */
    @Excel(name = "指定分配人", width = 15)
    @ApiModelProperty(value = "指定分配人")
    private String distributionName;
    /**
     * 部门id
     */
    @Excel(name = "部门id", width = 15)
    @ApiModelProperty(value = "部门id")
    private String departmentId;
    /**
     * 管理员名称
     */
    @Excel(name = "管理员名称", width = 15)
    @ApiModelProperty(value = "管理员名称")
    private String adminName;
    /**
     * 广告主名称
     */
    @Excel(name = "广告主名称", width = 15)
    @ApiModelProperty(value = "广告主名称")
    private String advertiserName;
    /**
     * 输入账号  --登陆
     */
    @Excel(name = "输入账号  --登陆", width = 15)
    @ApiModelProperty(value = "输入账号  --登陆")
    private String accountName;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 操作人姓名
     */
    @Excel(name = "操作人姓名", width = 15)
    @ApiModelProperty(value = "操作人姓名")
    private String operationName;
    /**
     * 授权名称
     */
    @Excel(name = "授权名称", width = 15)
    @ApiModelProperty(value = "授权名称")
    private String authName;
    /**
     * 创建人
     */
    @Excel(name = "创建人", width = 15)
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 修改人
     */
    @Excel(name = "修改人", width = 15)
    @ApiModelProperty(value = "修改人")
    private String updateBy;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    /**
     * 平台类型 1 头条 2快手
     */
    @Excel(name = "平台类型 1 头条 2快手", width = 15)
    @ApiModelProperty(value = "平台类型 1 头条 2快手")
    private String mediaId;

}
