package cn.com.ctop.kuaishou.modules.graphql.service.impl;

import cn.com.ctop.common.module.entity.HttpClientEntity;
import cn.com.ctop.common.module.utils.HttpClientUtils;
import cn.com.ctop.common.module.utils.HttpUtils2;
import cn.com.ctop.kuaishou.modules.graphql.entity.*;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouUserCookieService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouUserService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouVideoService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouWebInterfaceService;
import cn.com.ctop.kuaishou.modules.graphql.vo.KuaishouAcceptVO;
import cn.com.ctop.kuaishou.modules.graphql.vo.KuaishouQrStartVO;
import cn.com.ctop.kuaishou.modules.graphql.vo.KuaishouUserVO;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.gson.Gson;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FileUtils;
import org.apache.http.HttpResponse;
import org.apache.http.client.CookieStore;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.cookie.BasicClientCookie;
import org.apache.http.impl.cookie.BasicClientCookie2;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.RedisUtil;
import org.openqa.selenium.*;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.chrome.ChromeDriverService;
import org.openqa.selenium.chrome.ChromeOptions;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.imageio.ImageIO;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.List;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Slf4j
@Service
public class KuaishouWebInterfaceServiceImpl implements IKuaishouWebInterfaceService {
    @Autowired
    private IKuaishouUserService kuaishouUserService;
    @Autowired
    private IKuaishouVideoService kuaishouVideoService;
    @Autowired
    private IKuaishouUserCookieService kuaishouUserCookieService;
    @Autowired
    private RedisUtil redisUtil;
    public static String GRAPHQL_URL = "https://live.kuaishou.com/graphql";

    private String qrCallback(String qrToken) {
        Map<String, Object> params = new HashMap<>();
        Map<String, String> headers = new HashMap<>();
        params.put("qrToken", qrToken);
        params.put("sid", "kuaishou.live.web");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0");
        headers.put("Accept", "application/json, text/plain, */*");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Referer", "https://live.kuaishou.com/");
        headers.put("Content-Type", "application/x-www-form-urlencoded");
        headers.put("Origin", "https://live.kuaishou.com");
        headers.put("Connection", "keep-alive");
        headers.put("Cookie", "did=web_064a1df2953c429a9770308d73d42bdb; didv=1566549687000; clientid=3; client_key=65890b29; Hm_lvt_86a27b7db2c5c0ae37fee4a8a35033ee=1568871207,1569462190");
        String url = "https://id.kuaishou.com/pass/kuaishou/login/qr/callback";
        String s = HttpUtils2.httpPostParamRequest(url, params, headers);
        System.out.println(s);
        return s;
        //kuaishou.live.web.at  kuaishou.live.web_st  passToken result ssecurity userId
        //cookie  userId passToken
    }

    private String acceptResult(String qrLoginToken, String qrLoginSignature) {
        Map<String, Object> params = new HashMap<>();
        Map<String, String> headers = new HashMap<>();
        params.put("qrLoginToken", qrLoginToken);
        params.put("qrLoginSignature", qrLoginSignature);
        params.put("sid", "kuaishou.live.web");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0");
        headers.put("Accept", "application/json, text/plain, */*");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Referer", "https://live.kuaishou.com/");
        headers.put("Content-Type", "application/x-www-form-urlencoded");
        headers.put("Origin", "https://live.kuaishou.com");
        headers.put("Connection", "keep-alive");
        headers.put("Cookie", "did=web_064a1df2953c429a9770308d73d42bdb; didv=1566549687000; clientid=3; client_key=65890b29; Hm_lvt_86a27b7db2c5c0ae37fee4a8a35033ee=1568871207,1569462190");
        String url = "https://id.kuaishou.com/rest/c/infra/ks/qr/acceptResult";
        String s = HttpUtils2.httpPostParamRequest(url, params, headers);
        System.out.println(s);
        return s;
        //callback   qrToken  result  sid
    }

    private String scanResult(String qrLoginToken, String qrLoginSignature) {
        Map<String, Object> params = new HashMap<>();
        Map<String, String> headers = new HashMap<>();
        params.put("qrLoginToken", qrLoginToken);
        params.put("qrLoginSignature", qrLoginSignature);
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0");
        headers.put("Accept", "application/json, text/plain, */*");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Referer", "https://live.kuaishou.com/");
        headers.put("Content-Type", "application/x-www-form-urlencoded");
        headers.put("Origin", "https://live.kuaishou.com");
        headers.put("Connection", "keep-alive");
        headers.put("Cookie", "did=web_064a1df2953c429a9770308d73d42bdb; didv=1566549687000; clientid=3; client_key=65890b29; Hm_lvt_86a27b7db2c5c0ae37fee4a8a35033ee=1568871207,1569462190");
        String url = "https://id.kuaishou.com/rest/c/infra/ks/qr/scanResult";
        String s = HttpUtils2.httpPostParamRequest(url, new HashMap<>(), new HashMap<>());
        System.out.println(s);
        return s;
//        {"result":707,"error_msg":"登录二维码已过期"}
//        {"result":1,"user":{"eid":"3x6wv7iyb8pzjty","headurls":[{"cdn":"tx2.a.yximgs.com","url":"https://tx2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg"},{"cdn":"js2.a.yximgs.com","url":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","urlPattern":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg@base@tag%3DimgScale%26r%3D0%26q%3D85%26w%3D{w}%26h%3D{h}%26rotate"}],"headurl":"https://tx2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","user_sex":"M","user_id":1153842485,"user_name":"许祚云"}}

    }

    private String liveQRLogin() throws IOException {

        Map<String, Object> params = new HashMap<>();
        Map<String, String> headers = new HashMap<>();
        params.put("sid", "kuaishou.live.web");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0");
        headers.put("Accept", "application/json, text/plain, */*");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Referer", "https://live.kuaishou.com/");
        headers.put("Content-Type", "application/x-www-form-urlencoded");
        headers.put("Origin", "https://live.kuaishou.com");
        headers.put("Connection", "keep-alive");
        headers.put("Cookie", "did=web_064a1df2953c429a9770308d73d42bdb; didv=1566549687000; clientid=3; client_key=65890b29; Hm_lvt_86a27b7db2c5c0ae37fee4a8a35033ee=1568871207,1569462190");
        String url = "https://id.kuaishou.com/rest/c/infra/ks/qr/start";
        String s = HttpUtils2.httpPostParamRequest(url, params, headers);
        System.out.println(s);
        return s;
    }

    public void getSearchUserList(String keyword, int page, String ttf) {
        String jsonStr = "{\"operationName\":\"SearchDetailQuery\",\"variables\":{\"key\":\"" + keyword + "\",\"type\":\"author\",\"page\":" + String.valueOf(page) + ",\"lssid\":null,\"ussid\":\"MV8wXzE1NjA4NTgzMjMzODdf5ri45oiPXzk3MTE\"},\"query\":\"query SearchDetailQuery($key: String, $type: String, $page: Int, $lssid: String, $ussid: String) {  searchDetail(key: $key, type: $type, page: $page, lssid: $lssid, ussid: $ussid) {    ... on SearchCategoryList {      type      list {        id        categoryId        title        src        roomNumber        __typename      }      __typename    }    ... on SearchUserList {      type      ussid      list {        id        name        living        profile        sex        description        countsInfo {          fan          follow          photo          __typename        }        __typename      }      __typename    }    ... on SearchLivestreamList {      type      lssid      list {        user {          id          profile          name          __typename        }        watchingCount        src        title        gameId        gameName        categoryId        liveStreamId        playUrls {          quality          url          __typename        }        quality        gameInfo {          category          name          pubgSurvival          type          kingHero          __typename        }        redPack        liveGuess        expTag        __typename      }      __typename    }    __typename  }}\"}";
        try {
            if (page < 1) {
                page = 1;
            }
            String result = HttpUtils2.callingGraph(GRAPHQL_URL, jsonStr);
            Map<String, String> map = HttpUtils2.fontsMap.get(ttf);
            for (String key : map.keySet()) {
                result = result.replace(key, map.get(key));
            }
            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
            KuaishouWebResult<KuaishouSearchResult> data = mapper.readValue(result, new TypeReference<KuaishouWebResult<KuaishouSearchResult>>() {
            });
            List<KuaishouAuthors> list = data.getData().getSearchDetail().getList();
            if (list != null && list.size() > 0) {
                Thread.sleep((int) Math.random() * 5000 + 5000);
                getSearchUserList(keyword, ++page, ttf);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String userInfoQuery() {
        String queryStr = "{\"operationName\":\"userInfoQuery\",\"variables\":{},\"query\":\"query userInfoQuery {\\n  kshellBalance {\\n    kshell\\n    __typename\\n  }\\n  ownerInfo {\\n    id\\n    principalId\\n    kwaiId\\n    eid\\n    userId\\n    profile\\n    name\\n    description\\n    sex\\n    constellation\\n    cityName\\n    following\\n    living\\n    watchingCount\\n    isNew\\n    privacy\\n    timestamp\\n    feeds {\\n      eid\\n      photoId\\n      thumbnailUrl\\n      timestamp\\n      __typename\\n    }\\n    verifiedStatus {\\n      verified\\n      description\\n      type\\n      new\\n      __typename\\n    }\\n    countsInfo {\\n      fan\\n      follow\\n      photo\\n      liked\\n      open\\n      playback\\n      private\\n      __typename\\n    }\\n    bannedStatus {\\n      banned\\n      defriend\\n      isolate\\n      socialBanned\\n      __typename\\n    }\\n    __typename\\n  }\\n}\\n\"}";
        return queryStr;
    }

    public String userLogin(String qrToken) {
        String queryStr = "{\"operationName\":\"UserLogin\",\"variables\":{\"userLoginInfo\":{\"authToken\":\"" + qrToken + "\",\"sid\":\"kuaishou.live.web\"}},\"query\":\"mutation UserLogin($userLoginInfo: FlatObject) {\\n  login(userLoginInfo: $userLoginInfo) {\\n    result\\n    __typename\\n  }\\n}\\n\"}";
        return queryStr;
    }

    public String subCommentListQuery(String photoId, Long rootCommentId, String pcursor) {
        String queryStr = "{\"operationName\":\"subCommentListQuery\",\"variables\":{\"photoId\":\"" + photoId + "\",\"rootCommentId\":\"" + rootCommentId + "\",\"pcursor\":\"" + pcursor + "\",\"count\":20},\"query\":\"query subCommentListQuery($photoId: String, $rootCommentId: String, $pcursor: String, $count: Int) {\\n  subCommentList(photoId: $photoId, rootCommentId: $rootCommentId, pcursor: $pcursor, count: $count) {\\n    pcursor\\n    subCommentsList {\\n      commentId\\n      authorId\\n      authorName\\n      content\\n      headurl\\n      timestamp\\n      authorEid\\n      status\\n      replyToUserName\\n      replyTo\\n      replyToEid\\n      __typename\\n    }\\n    __typename\\n  }\\n}\\n\"}";
        return queryStr;
    }

    public String commentListQuery(String photoId, String pcursor) {
        String queryStr = "{\"operationName\":\"commentListQuery\",\"variables\":{\"pcursor\":\"" + pcursor + "\",\"photoId\":\"" + photoId + "\",\"page\":1,\"count\":20},\"query\":\"query commentListQuery($photoId: String, $page: Int, $pcursor: String, $count: Int) {\\n  shortVideoCommentList(photoId: $photoId, page: $page, pcursor: $pcursor, count: $count) {\\n    commentCount\\n    realCommentCount\\n    pcursor\\n    commentList {\\n      commentId\\n      authorId\\n      authorName\\n      content\\n      headurl\\n      timestamp\\n      authorEid\\n      status\\n      subCommentCount\\n      subCommentsPcursor\\n      likedCount\\n      liked\\n      subComments {\\n        commentId\\n        authorId\\n        authorName\\n        content\\n        headurl\\n        timestamp\\n        authorEid\\n        status\\n        replyToUserName\\n        replyTo\\n        replyToEid\\n        __typename\\n      }\\n      __typename\\n    }\\n    __typename\\n  }\\n}\\n\"}";
        return queryStr;
    }

    public String videoFeeds(String principalId, String pcursor) {
        String queryStr = "{\"operationName\":\"publicFeedsQuery\",\"variables\":{\"principalId\":\"" + principalId + "\",\"pcursor\":\"" + pcursor + "\",\"count\":24},\"query\":\"query publicFeedsQuery($principalId: String, $pcursor: String, $count: Int) {\\n  publicFeeds(principalId: $principalId, pcursor: $pcursor, count: $count) {\\n    pcursor\\n    live {\\n      user {\\n        id\\n        kwaiId\\n        eid\\n        profile\\n        name\\n        living\\n        __typename\\n      }\\n      watchingCount\\n      src\\n      title\\n      gameId\\n      gameName\\n      categoryId\\n      liveStreamId\\n      playUrls {\\n        quality\\n        url\\n        __typename\\n      }\\n      followed\\n      type\\n      living\\n      redPack\\n      liveGuess\\n      anchorPointed\\n      latestViewed\\n      expTag\\n      __typename\\n    }\\n    list {\\n      photoId\\n      caption\\n      thumbnailUrl\\n      poster\\n      viewCount\\n      likeCount\\n      commentCount\\n      timestamp\\n      workType\\n      type\\n      useVideoPlayer\\n      imgUrls\\n      imgSizes\\n      magicFace\\n      musicName\\n      location\\n      liked\\n      onlyFollowerCanComment\\n      relativeHeight\\n      width\\n      height\\n      user {\\n        id\\n        eid\\n        name\\n        profile\\n        __typename\\n      }\\n      expTag\\n      __typename\\n    }\\n    __typename\\n  }\\n}\\n\"}";
        return queryStr;
    }

    public Map<String, Object> subCommentList(String ksid, String photoId, Long rootCommentId, String pcursor) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<KuaishouUserCookie> queryWrapper = new QueryWrapper<KuaishouUserCookie>();
        Map<String, Object> resultMap = new HashMap<>();
        queryWrapper.eq("user_id", user.getId());
        queryWrapper.eq("ksid", ksid);
        KuaishouUserCookie kuaishouUserCookie = kuaishouUserCookieService.getOne(queryWrapper);
        if (kuaishouUserCookie != null) {
            if (pcursor == null) {
                pcursor = "";
            }
            Map<String, Object> params = new HashMap<String, Object>();
            HttpClientEntity httpClientEntity = new HttpClientEntity();
            HttpClientUtils httpClientUtils = new HttpClientUtils();
            httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
            httpClientEntity.setResult("");
            httpClientEntity.setCookieStore(cookieTransfer(kuaishouUserCookie.getCookie()));
            httpClientEntity.setHeaders(getHeaders());
            httpClientEntity.setParams(params);
            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity, subCommentListQuery(photoId, rootCommentId, pcursor));
            try {
                ObjectMapper mapper = new ObjectMapper();
                resultMap = mapper.readValue(httpClientEntity.getResult(), new TypeReference<Map<String, Object>>() {
                });
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return resultMap;
    }

    public Map<String, Object> commentList(String ksid, String photoId, String pcursor) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<KuaishouUserCookie> queryWrapper = new QueryWrapper<KuaishouUserCookie>();
        Map<String, Object> resultMap = new HashMap<>();
        queryWrapper.eq("user_id", user.getId());
        queryWrapper.eq("ksid", ksid);
        KuaishouUserCookie kuaishouUserCookie = kuaishouUserCookieService.getOne(queryWrapper);
        if (kuaishouUserCookie != null) {
            if (pcursor == null) {
                pcursor = "";
            }
            Map<String, Object> params = new HashMap<String, Object>();
            HttpClientEntity httpClientEntity = new HttpClientEntity();
            HttpClientUtils httpClientUtils = new HttpClientUtils();
            httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
            httpClientEntity.setResult("");
            httpClientEntity.setCookieStore(cookieTransfer(kuaishouUserCookie.getCookie()));
            httpClientEntity.setHeaders(getHeaders());
            httpClientEntity.setParams(params);
            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity, commentListQuery(photoId, pcursor));
            try {
                ObjectMapper mapper = new ObjectMapper();
                resultMap = mapper.readValue(httpClientEntity.getResult(), new TypeReference<Map<String, Object>>() {
                });
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return resultMap;
    }

    public Map<String, Object> videoList(String ksid, String pcursor) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<KuaishouUserCookie> queryWrapper = new QueryWrapper<KuaishouUserCookie>();
        Map<String, Object> resultMap = new HashMap<>();
        queryWrapper.eq("user_id", user.getId());
        queryWrapper.eq("ksid", ksid);
        KuaishouUserCookie kuaishouUserCookie = kuaishouUserCookieService.getOne(queryWrapper);
        if (kuaishouUserCookie != null) {
            if (pcursor == null) {
                pcursor = "";
            }
            Map<String, Object> params = new HashMap<String, Object>();
            HttpClientEntity httpClientEntity = new HttpClientEntity();
            HttpClientUtils httpClientUtils = new HttpClientUtils();
            httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
            httpClientEntity.setResult("");
            httpClientEntity.setCookieStore(cookieTransfer(kuaishouUserCookie.getCookie()));
            httpClientEntity.setHeaders(getHeaders());
            httpClientEntity.setParams(params);
            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity, videoFeeds(kuaishouUserCookie.getEid(), pcursor));
            try {
                ObjectMapper mapper = new ObjectMapper();
                resultMap = mapper.readValue(httpClientEntity.getResult(), new TypeReference<Map<String, Object>>() {
                });
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return resultMap;
    }

    public Map<String, Object> commentDelete(String ksid, String photoId, Long commentId) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<KuaishouUserCookie> queryWrapper = new QueryWrapper<KuaishouUserCookie>();
        Map<String, Object> resultMap = new HashMap<>();
        queryWrapper.eq("user_id", user.getId());
        queryWrapper.eq("ksid", ksid);
        KuaishouUserCookie kuaishouUserCookie = kuaishouUserCookieService.getOne(queryWrapper);
        if (kuaishouUserCookie != null) {
            Map<String, Object> params = new HashMap<String, Object>();
            params.put("photoId", photoId);
            params.put("commentId", commentId);
            System.out.println(new Gson().toJson(params));
            HttpClientEntity httpClientEntity = new HttpClientEntity();
            HttpClientUtils httpClientUtils = new HttpClientUtils();
            httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
            httpClientEntity.setUrl("https://id.kuaishou.com/pass/kuaishou/login/qr/callback");
            httpClientEntity.setResult("");
            httpClientEntity.setCookieStore(cookieTransfer(kuaishouUserCookie.getCookie()));
            httpClientEntity.setHeaders(getHeaders());
            httpClientEntity.setParams(params);
            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
            try {
                ObjectMapper mapper = new ObjectMapper();
                resultMap = mapper.readValue(httpClientEntity.getResult(), new TypeReference<Map<String, Object>>() {
                });
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return resultMap;
    }

    private CookieStore cookieTransfer(String json) {
        CookieStore cookieStore = new BasicCookieStore();
        try {
            ObjectMapper mapper = new ObjectMapper();
            JsonNode jsonNode = mapper.readTree(json);
            SimpleDateFormat sdf = new SimpleDateFormat("MMM d, yyyy H:m:s aaa");
            if (jsonNode != null) {
                JsonNode cookiesNode = jsonNode.get("cookies");
                if (cookiesNode != null && cookiesNode.isArray()) {
                    Iterator<JsonNode> iterator = cookiesNode.iterator();
                    while (iterator.hasNext()) {
                        JsonNode cookieNode = iterator.next();
                        BasicClientCookie basicClientCookie = new BasicClientCookie(cookieNode.get("name").asText(), cookieNode.get("value").asText());
                        if (cookieNode.has("creationDate")) {
                            basicClientCookie.setCreationDate(sdf.parse(cookieNode.get("creationDate").asText()));
                        }
                        if (cookieNode.has("cookieExpiryDate")) {
                            basicClientCookie.setExpiryDate(sdf.parse(cookieNode.get("cookieExpiryDate").asText()));
                        }
                        if (cookieNode.has("cookieVersion")) {
                            basicClientCookie.setVersion(cookieNode.get("cookieVersion").asInt());
                        }
                        if (cookieNode.has("isSecure")) {
                            basicClientCookie.setSecure(cookieNode.get("isSecure").asBoolean());
                        }
                        if (cookieNode.has("cookieDomain")) {
                            basicClientCookie.setDomain(cookieNode.get("cookieDomain").asText());
                        }
                        if (cookieNode.has("cookiePath")) {
                            basicClientCookie.setPath(cookieNode.get("cookiePath").asText());
                        }
                        cookieStore.addCookie(basicClientCookie);
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cookieStore;
    }

    public void getVedioList(String principalId, String pcursor, String ttf, int times) {
        String jsonStr = "{" +
                "\"operationName\":\"publicFeedsQuery\"," +
                "\"variables\":{\"principalId\":\"" + principalId + "\",\"pcursor\":\"" + pcursor + "\",\"count\":24}," +
                "\"query\":\"query publicFeedsQuery($principalId: String, $pcursor: String, $count: Int) " +
                "{" +
                "publicFeeds(principalId: $principalId, pcursor: $pcursor, count: $count) " +
                "{    " +
                "pcursor    " +
                "live " +
                "{      " +
                "user " +
                "{        " +
                "id        " +
                "kwaiId        " +
                "eid        " +
                "profile        " +
                "name        " +
                "living        " +
                "}      " +
                "watchingCount      " +
                "src      " +
                "title      " +
                "gameId      " +
                "gameName      " +
                "categoryId      " +
                "liveStreamId      " +
                "playUrls " +
                "{        " +
                "quality        " +
                "url        " +
                "}      " +
                "followed      " +
                "type      " +
                "living      " +
                "redPack      " +
                "liveGuess      " +
                "anchorPointed      " +
                "latestViewed      " +
                "expTag      " +
                "}    " +
                "list " +
                "{      " +
                "photoId      " +
                "caption      " +
                "thumbnailUrl      " +
                "poster      " +
                "viewCount      " +
                "likeCount      " +
                "commentCount      " +
                "timestamp      " +
                "workType      " +
                "type      " +
                "useVideoPlayer      " +
                "imgUrls      " +
                "imgSizes      " +
                "magicFace      " +
                "musicName      " +
                "location      " +
                "liked      " +
                "onlyFollowerCanComment      " +
                "relativeHeight      " +
                "width      " +
                "height      " +
                "user " +
                "{        " +
                "id        " +
                "eid        " +
                "name        " +
                "profile        " +
                "}      " +
                "expTag      " +
                "}    " +
                "}" +
                "}\"" +
                "}";
        try {
            if (times > 5) {
                return;
            }
            String result = HttpUtils2.callingGraph(GRAPHQL_URL, jsonStr);
//            Map<String, String> map = HttpUtils2.fontsMap.get(ttf);
//            for (String key : map.keySet()) {
//                result = result.replace(key, map.get(key));
//            }
            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
            System.out.println(result);
            KuaishouWebResult<KuaishouWebData> data = mapper.readValue(result, new TypeReference<KuaishouWebResult<KuaishouWebData>>() {
            });
            KuaishouPublicFeeds feeds = data.getData().getPublicFeeds();
//            if (feeds.getList() != null && feeds.getList().size() > 0) {
//                List<KuaishouVideo> videoList = feeds.getList();
//                for (KuaishouVideo video : videoList) {
//                    video.setUserId(video.getUser().getId());
//                    video.setTimes(new Date(video.getTimestamp()));
//                    video.setTtfName(ttf);
//                    kuaishouUserService.saveOrUpdate(video.getUser());
//                    kuaishouVideoService.saveOrUpdate(video);
//                }
//            }
            if (feeds.getPcursor() == null || !"no_more".equals(feeds.getPcursor())) {
                Thread.sleep((int) Math.random() * 5000 + 10000);
                getVedioList(principalId, feeds.getPcursor(), ttf, ++times);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void getSecurity(String url) {
        String detectionPoint = "{\"a\":false,\"b\":true,\"c\":true,\"d\":true,\"e\":false,\"f\":false,\"g\":false,\"h\":true,\"i\":true,\"j\":false,\"k\":false,\"l\":true,\"m\":true,\"n\":true,\"o\":false,\"p\":false,\"q\":true,\"r\":false,\"s\":false,\"t\":false,\"u\":false,\"v\":false,\"w\":false,\"x\":false,\"y\":false,\"z\":true,\"aa\":false,\"bb\":false,\"cc\":false,\"dd\":false,\"ee\":false,\"ff\":false,\"gg\":false,\"hh\":false,\"ii\":false,\"jj\":false,\"kk\":false,\"ll\":false,\"mm\":false,\"nn\":false,\"oo\":false,\"pp\":1}";
        String collectInfo = "{\"a\":\"live.kuaishou.com\",\"b\":\"" + url + "\",\"c\":\"null的主页-快手直播\",\"d\":\"\",\"e\":\"" + HttpUtils2.USER_AGENT + "\",\"f\":1920,\"g\":1080,\"h\":24,\"i\":\"zh-CN\"}";
        try {
            String securityUrl = "https://live.kuaishou.com/rest/wd/live/web/security?detectionPoint=" + URLEncoder.encode(detectionPoint, "UTF-8") + "&collectInfo=" + URLEncoder.encode(collectInfo, "UTF-8");
            String html2 = HttpUtils2.httpGetRequest(securityUrl);
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
    }

    @Value("${jeecg.path.chrome-driver}")
    private String chromeDriver;

    @Override
    public void adkuaishouWebLogin(String phone, String password) throws IOException {
        ChromeDriverService service = new ChromeDriverService.Builder().usingDriverExecutable(new File(chromeDriver)).usingAnyFreePort().build();
        service.start();
//        System.getProperties().setProperty("webdriver.chrome.driver", chromeDriver);
        ChromeOptions chromeOptions = new ChromeOptions();
//        chromeOptions.addArguments("--proxy-server=http://111.231.92.21:8888");
        chromeOptions.addArguments("--headless");
        chromeOptions.addArguments("--no-sandbox");
        chromeOptions.addArguments("--disable-dev-shm-usage");
        chromeOptions.addArguments("--disable-gpu");
        chromeOptions.addArguments("--window-size=1920,1080");
        chromeOptions.addArguments("--user-agent=" + HttpUtils2.USER_AGENT);
        chromeOptions.setAcceptInsecureCerts(true);
        WebDriver webDriver = new RemoteWebDriver(service.getUrl(), chromeOptions);
//        WebDriver webDriver = new ChromeDriver(chromeOptions);
        try {

            //全局隐式等待
            webDriver.manage().timeouts().implicitlyWait(10, TimeUnit.SECONDS);
            //设定网址
            webDriver.get("https://b.e.kuaishou.com");
            //显示等待控制对象
            WebDriverWait webDriverWait = new WebDriverWait(webDriver, 10);
            webDriverWait.until(ExpectedConditions.elementToBeClickable(By.cssSelector(".phone input"))).sendKeys(phone);
            webDriverWait.until(ExpectedConditions.elementToBeClickable(By.cssSelector(".password input"))).sendKeys(password);
            //点击登录
            webDriver.findElement(By.className("foot")).click();
            //等待2秒用于页面加载，保证Cookie响应全部获取。

            Thread.sleep(10000);
//            String text = webDriver.findElement(By.tagName("iframe")).getAttribute("src");
//            System.out.println(text);
//            webDriver.get(text);

//            System.out.println(webDriver.getPageSource());

//            String src = webDriver.findElement(By.id("clickCharTips")).getAttribute("src");
//            System.out.println(src);
//            Actions actions = new Actions(webDriver);
//            actions.moveToElement(webDriver.findElement(By.className("aq_icon_refresh")));
//            actions.moveByOffset(10,10);
//            actions.moveByOffset(100,100);
//            actions.click();

//            webDriver.switchTo().frame(webDriver.findElement(By.tagName("iframe")));
//            File scrFile = ((TakesScreenshot)webDriver).getScreenshotAs(OutputType.FILE);
//            WebElement iframeElement = webDriver.findElement(By.tagName("iframe"));
//            if (iframeElement != null) {
//                File scrFile = captureElement(webDriver.findElement(By.tagName("iframe")));
//                String savePath = "D:/capter.png";
//                FileUtils.copyFile(scrFile, new File(savePath));
//                webDriver.switchTo().frame(webDriver.findElement(By.tagName("iframe")));
//                String result = ChaojiyingUtils.process(Base64Utils.ImageToBase64(savePath));
//                System.out.println(result);
//                ((JavascriptExecutor) webDriver).executeScript("arguments[0].click();", webDriver.findElement(By.className("aq_icon_refresh")));
//            }


            webDriver.get("https://b.e.kuaishou.com/#/home/profile");
            //获取Cookie并打印
            Set<org.openqa.selenium.Cookie> cookies = webDriver.manage().getCookies();
            Iterator iterator = cookies.iterator();
            CookieStore cookieStore = new BasicCookieStore();
            String infoUrl = "https://b.e.kuaishou.com/rest/business/commentInfo/photos";
            Map<String, String> parameterMap = new HashMap<String, String>();
            parameterMap.put("pcursorMap", new Gson().toJson(new HashMap<>()));
            parameterMap.put("count", "30");
            while (iterator.hasNext()) {
                String cookieStr = iterator.next().toString();
                String[] cookieArray = cookieStr.split(";");
                Map<String, String> cookieMap = new HashMap<String, String>();
                for (String cookie : cookieArray) {
                    String[] kv = cookie.split("=");
                    if (kv.length > 1) {
                        cookieMap.put(kv[0].trim(), kv[1].trim());
                    }
                }
                BasicClientCookie clientCookie = new BasicClientCookie(cookieArray[0].split("=")[0],
                        cookieArray[0].split("=")[1]);
                clientCookie.setDomain("b.e.kuaishou.com");
                clientCookie.setPath(cookieMap.get("path"));
                HttpUtils2.cookieStore.addCookie(clientCookie);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
//            webDriver.quit();
//            service.stop();
//            HttpUtils.cookieStore.clear();
        }
    }

    public File captureElement(WebElement element) throws Exception {
        // TODO Auto-generated method stub
        WrapsDriver wrapsDriver = (WrapsDriver) element;
        // 截图整个页面
        File screen = ((TakesScreenshot) wrapsDriver.getWrappedDriver()).getScreenshotAs(OutputType.FILE);
//        ((TakesScreenshot) wrapsDriver.getWrappedDriver()).getScreenshotAs(OutputType.)
        String tempPath = "D:/temp.png";
        FileUtils.copyFile(screen, new File(tempPath));
        BufferedImage img = ImageIO.read(new File(tempPath));
        // 获得元素的高度和宽度
        int width = element.getSize().getWidth();
        int height = element.getSize().getHeight();
//        // 创建一个矩形使用上面的高度，和宽度
        Rectangle rect = new Rectangle(width, height);
//        // 得到元素的坐标
        Point p = element.getLocation();
        BufferedImage dest = img.getSubimage(p.x, p.y, rect.width, rect.height);
        // 存为png格式
        ImageIO.write(dest, "png", screen);
        return screen;
    }

    @Override
    public void getVideoList(String uid) throws IOException {
        ChromeDriverService service = new ChromeDriverService.Builder().usingDriverExecutable(new File(chromeDriver)).usingAnyFreePort().build();
        service.start();
//        System.getProperties().setProperty("webdriver.chrome.driver", chromeDriver);
        ChromeOptions chromeOptions = new ChromeOptions();
        chromeOptions.addArguments("--headless");
        chromeOptions.addArguments("--no-sandbox");
        chromeOptions.addArguments("--disable-gpu");
        chromeOptions.addArguments("--window-size=1290,1080");
        chromeOptions.addArguments("--user-agent=" + HttpUtils2.USER_AGENT);
        chromeOptions.setAcceptInsecureCerts(true);
        WebDriver webDriver = new ChromeDriver(chromeOptions);
        try {

            webDriver.get("https://live.kuaishou.com/profile/" + uid);
            Thread.sleep(2000);
            webDriver.navigate().refresh();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            for (org.openqa.selenium.Cookie cookie : webDriver.manage().getCookies()) {
                BasicClientCookie ck = new BasicClientCookie(cookie.getName(), cookie.getValue());
                ck.setDomain("live.kuaishou.com");
//                ck.setDomain(cookie.getDomain());
                ck.setExpiryDate(cookie.getExpiry());
                ck.setPath(cookie.getPath());
                HttpUtils2.cookieStore.addCookie(ck);
            }
            String html = webDriver.getPageSource();
            Pattern p = Pattern.compile("fontscn\\w+\\.ttf");
            Matcher m = p.matcher(html);

            String ttf = "";
            while (m.find()) {
                ttf = m.group();
            }
            Map<String, String> map = HttpUtils2.fontsMap.get(ttf);
            if (map == null) {
                HttpUtils2.kuaishouTtf(ttf);
            }
            getVedioList(uid, "", ttf, 1);

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
//            HttpUtils.cookieStore.clear();
            //获得cookie
            Set<org.openqa.selenium.Cookie> coo = webDriver.manage().getCookies();
            //清除所有的缓存
            webDriver.manage().deleteAllCookies();
            webDriver.quit();
            service.stop();
        }
    }

    private void setCookies() {
        HttpUtils2.cookieStore.clear();
        KuaishouWebInterfaceServiceImpl i = new KuaishouWebInterfaceServiceImpl();
        BasicClientCookie cookie = new BasicClientCookie("clientid", "3");
        //设置范围
        cookie.setDomain("live.kuaishou.com");
        cookie.setPath("/");
        cookie.setExpiryDate(new Date(System.currentTimeMillis() + 1000 * 60 * 60 * 24 * 365));
        HttpUtils2.cookieStore.addCookie(cookie);

        BasicClientCookie cookie1 = new BasicClientCookie("did", "web_064a1df2953c429a9770308d73d42bdb");
        //设置范围web_a5735c4f9f02ad9ee48677499927341c
        cookie1.setDomain("live.kuaishou.com");
        cookie1.setPath("/");
        cookie1.setExpiryDate(new Date(System.currentTimeMillis() + 1000 * 60 * 60 * 24 * 365));
        HttpUtils2.cookieStore.addCookie(cookie1);

        BasicClientCookie cookie2 = new BasicClientCookie("client_key", "65890b29");
        //设置范围
        cookie2.setDomain("live.kuaishou.com");
        cookie2.setPath("/");
        cookie2.setExpiryDate(new Date(System.currentTimeMillis() + 1000 * 60 * 60 * 24 * 365));
        HttpUtils2.cookieStore.addCookie(cookie2);

        BasicClientCookie cookie3 = new BasicClientCookie("kuaishou.live.bfb1s", "3e261140b0cf7444a0ba411c6f227d88");
        //设置范围
        cookie3.setDomain("live.kuaishou.com");
        cookie3.setPath("/");
        cookie3.setExpiryDate(new Date(System.currentTimeMillis() + 1000 * 60 * 60 * 24 * 365));
        HttpUtils2.cookieStore.addCookie(cookie3);

        BasicClientCookie cookie4 = new BasicClientCookie("didv", "1566549687000");
        //设置范围web_a5735c4f9f02ad9ee48677499927341c
        cookie4.setDomain("live.kuaishou.com");
        cookie4.setPath("/");
        cookie4.setExpiryDate(new Date(System.currentTimeMillis() + 1000 * 60 * 60 * 24 * 365));
        HttpUtils2.cookieStore.addCookie(cookie4);

        BasicClientCookie cookie5 = new BasicClientCookie("Hm_lvt_86a27b7db2c5c0ae37fee4a8a35033ee", "1568871207,1569462190");
        //设置范围web_a5735c4f9f02ad9ee48677499927341c
        cookie5.setDomain("live.kuaishou.com");
        cookie5.setPath("/");
        cookie5.setExpiryDate(new Date(System.currentTimeMillis() + 1000 * 60 * 60 * 24 * 365));
        HttpUtils2.cookieStore.addCookie(cookie5);
    }

    @Override
    public String checkKuaishouUser(String videoUrl) {
        String html = HttpUtils2.httpGetRequest(videoUrl);
        HttpUtils2.cookieStore.clear();
        Pattern p = Pattern.compile("/profile/(\\w+)\"");
        Matcher m = p.matcher(html);
        String uid = "";

        while (m.find()) {
            uid = m.group().replace("/profile/", "").replace("\"", "");
            if (uid != null && !"".equals(uid) && !"null".equals(uid)) {
                return uid;
            }
        }
        return null;
    }

    public void deleteCommentById(Long photoId, Long commentId, Map<String, String> headers) {
        try {
            Map<String, Object> params = new HashMap<>();
            params.put("photoId", photoId);
            params.put("commentId", commentId);
            params.put("principalUserId", 0);
            String str = HttpUtils2.httpPostRequest("https://b.e.kuaishou.com/rest/kd/ad/comment/deleteV2", params, headers);
            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
            JsonNode node = mapper.readTree(str);
            Integer result = node.get("result").asInt();
            if (result == 1) {
                System.out.println(photoId + "," + commentId + "删除成功");
            } else {
                System.out.println(photoId + "," + commentId + "删除失败");
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void deletePhotoComment(Long photoId, String pcursor, Map<String, String> headers) {
        try {
            Map<String, Object> params = new HashMap<>();
            params.put("photoId", photoId);
            params.put("pcursor", pcursor);
            String str = HttpUtils2.httpPostRequest("https://b.e.kuaishou.com/rest/kd/ad/comment/list", params, headers);
            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
            JsonNode node = mapper.readTree(str);
            Integer result = node.get("result").asInt();
            pcursor = node.get("pcursor").asText();
            if (result == 1) {
                Iterator<JsonNode> nodes = node.get("rootComments").iterator();
                while (nodes.hasNext()) {
                    JsonNode commentNode = nodes.next();
                    Long commentId = commentNode.get("comment_id").asLong();
                    deleteCommentById(photoId, commentId, headers);
                }
                if (pcursor != null && !"no_more".equals(pcursor)) {
                    deletePhotoComment(photoId, pcursor, headers);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void deleteAllComment(Map<String, String> pcursorMap) {
        try {
            Map<String, String> headers = new HashMap<>();
            Map<String, Object> params = new HashMap<>();
            headers.put("Origin", "https://b.e.kuaishou.com");
            headers.put("Referer", "https://b.e.kuaishou.com/");
            headers.put("Host", "b.e.kuaishou.com");
            headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36");
            params.put("pcursorMap", pcursorMap);
            params.put("count", 30);
            String str = HttpUtils2.httpPostRequest("https://b.e.kuaishou.com/rest/business/commentInfo/photos", params, headers);
            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
            JsonNode node = mapper.readTree(str);
            Integer result = node.get("result").asInt();
            String pcursor = node.get("pcursor").asText();
            if (result == 1) {
                Iterator<JsonNode> nodes = node.get("photos").iterator();
                while (nodes.hasNext()) {
                    JsonNode photoNode = nodes.next();
                    Long photoId = photoNode.get("photoId").asLong();
                    deletePhotoComment(photoId, "", headers);
                }
                if (pcursor != null && !"no_more".equals(pcursor)) {
                    pcursorMap = mapper.readValue(node.get("pcursorMap").toString(), new TypeReference<Map<String, String>>() {
                    });
                    deleteAllComment(pcursorMap);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

//    public String commentListQuery(){
//        String queryStr = "{\"operationName\":\"commentListQuery\",\"variables\":{\"pcursor\":\"\",\"photoId\":\"3x4idgu3eskgmni\",\"page\":1,\"count\":20},\"query\":\"query commentListQuery($photoId: String, $page: Int, $pcursor: String, $count: Int) {\\n  shortVideoCommentList(photoId: $photoId, page: $page, pcursor: $pcursor, count: $count) {\\n    commentCount\\n    realCommentCount\\n    pcursor\\n    commentList {\\n      commentId\\n      authorId\\n      authorName\\n      content\\n      headurl\\n      timestamp\\n      authorEid\\n      status\\n      subCommentCount\\n      subCommentsPcursor\\n      likedCount\\n      liked\\n      subComments {\\n        commentId\\n        authorId\\n        authorName\\n        content\\n        headurl\\n        timestamp\\n        authorEid\\n        status\\n        replyToUserName\\n        replyTo\\n        replyToEid\\n        __typename\\n      }\\n      __typename\\n    }\\n    __typename\\n  }\\n}\\n\"}";
//        return queryStr;
//    }

    private Map<String, String> getHeaders() {
        Map<String, String> headers = new HashMap<String, String>();
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0");
        headers.put("Accept", "application/json, text/plain, */*");
        headers.put("Accept-Language", "zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Referer", "https://live.kuaishou.com/");
        headers.put("Content-Type", "application/x-www-form-urlencoded");
        headers.put("Origin", "https://live.kuaishou.com");
        headers.put("Connection", "keep-alive");
        return headers;
    }

    public HttpClientEntity kuaishouQrCallback(HttpClientEntity httpClientEntity, String qrToken) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("qrToken", qrToken);
        params.put("sid", "kuaishou.live.web");
        System.out.println(new Gson().toJson(params));
        HttpClientUtils httpClientUtils = new HttpClientUtils();
        httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
        httpClientEntity.setUrl("https://id.kuaishou.com/pass/kuaishou/login/qr/callback");
        httpClientEntity.setResult("");
        httpClientEntity.setHeaders(getHeaders());
        httpClientEntity.setParams(params);
        httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
        return httpClientEntity;
    }

    public HttpClientEntity kuaishouQrAcceptResult(HttpClientEntity httpClientEntity, String qrLoginToken, String qrLoginSignature, Long ksid) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("qrLoginSignature", qrLoginSignature);
        params.put("sid", "kuaishou.live.web");
        params.put("qrLoginToken", qrLoginToken);
        System.out.println(new Gson().toJson(params));
        HttpClientUtils httpClientUtils = new HttpClientUtils();
        httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
        httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/acceptResult");
        httpClientEntity.setResult("");
        httpClientEntity.setHeaders(getHeaders());
        httpClientEntity.setParams(params);
        httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
        return httpClientEntity;
    }

    public HttpClientEntity kuaishouQrScanResult(HttpClientEntity httpClientEntity, String qrLoginToken, String qrLoginSignature) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("qrLoginSignature", qrLoginSignature);
        params.put("qrLoginToken", qrLoginToken);
        System.out.println(new Gson().toJson(params));
        HttpClientUtils httpClientUtils = new HttpClientUtils();
        httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
        httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/scanResult");
        httpClientEntity.setResult("");
        httpClientEntity.setHeaders(getHeaders());
        httpClientEntity.setParams(params);
        httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
        return httpClientEntity;
    }

    public HttpClientEntity kuaishouQrStart(HttpClientEntity httpClientEntity) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("sid", "kuaishou.live.web");
        HttpClientUtils httpClientUtils = new HttpClientUtils();
        httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
        httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/start");
        httpClientEntity.setResult("");
        httpClientEntity.setHeaders(getHeaders());
        httpClientEntity.setParams(params);
        httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
        return httpClientEntity;
    }

    public Date getCST(String strGMT) throws ParseException {
        if (strGMT == null) {
            return null;
        }
        DateFormat df = new SimpleDateFormat("MMM d, yyyy H:m:s aaa", Locale.ENGLISH);
        return df.parse(strGMT);

    }

    public HttpClientEntity kuaishouIndex() {
        HttpClientEntity httpClientEntity = new HttpClientEntity();
        HttpClientUtils httpClientUtils = new HttpClientUtils();
        httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
        httpClientEntity.setHeaders(getHeaders());
        httpClientEntity.setParams(new HashMap<>());
        httpClientEntity.setUrl("https://live.kuaishou.com/rest/wd/live/web/log");
        httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
        httpClientEntity.setUrl("https://live.kuaishou.com");
        httpClientEntity.setResult("");
        httpClientEntity = httpClientUtils.httpGetRequest(httpClientEntity);
        return httpClientEntity;
    }

    public String qrLogin(String taskId) throws Exception {
        HttpClientEntity httpClientEntity = this.kuaishouIndex();
        httpClientEntity = this.kuaishouQrStart(httpClientEntity);
        HttpClientUtils httpClientUtils = new HttpClientUtils();
        System.out.println(httpClientEntity.getResult());
        String result = httpClientEntity.getResult();
        ObjectMapper mapper = new ObjectMapper();
        mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
        KuaishouQrStartVO kuaishouQrStartVO = mapper.readValue(result, KuaishouQrStartVO.class);
        final HttpClientEntity finalHttpClientEntity = httpClientEntity;
        if (kuaishouQrStartVO.getResult() == 1) {
            Thread thread = new Thread() {
                @Override
                public void run() {
                    HttpClientEntity threadHttpClientEntity = null;
                    KuaishouUserVO kuaishouUserVO = null;
                    KuaishouAcceptVO kuaishouAcceptVO = null;
                    try {
                        threadHttpClientEntity = kuaishouQrScanResult(finalHttpClientEntity, kuaishouQrStartVO.getQrLoginToken(), kuaishouQrStartVO.getQrLoginSignature());
                        System.out.println(threadHttpClientEntity.getResult());
                        String res = threadHttpClientEntity.getResult();
                        JsonNode jsonNode = mapper.readTree(res);
                        Integer resultCode = jsonNode.get("result").asInt();
                        if (resultCode == 1) {
                            Map<String, Object> loginStatusMap = new HashMap<String, Object>();
                            loginStatusMap.put("status", 2);
                            loginStatusMap.put("msg", "扫码成功，请在手机确认登陆");
                            redisUtil.set(taskId, loginStatusMap, 60000);
                            kuaishouUserVO = mapper.readValue(jsonNode.get("user").toString(), KuaishouUserVO.class);
                        } else {
                            Map<String, Object> loginStatusMap = new HashMap<String, Object>();
                            loginStatusMap.put("status", -101);
                            loginStatusMap.put("msg", "二维码已过期，请重新获取");
                            redisUtil.set(taskId, loginStatusMap, 60000);
                            return;
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        Map<String, Object> loginStatusMap = new HashMap<String, Object>();
                        loginStatusMap.put("status", -100);
                        loginStatusMap.put("msg", "服务异常,请重新获取二维码");
                        redisUtil.set(taskId, loginStatusMap, 60000);
                        return;
                    }

                    try {
                        threadHttpClientEntity = kuaishouQrAcceptResult(threadHttpClientEntity, kuaishouQrStartVO.getQrLoginToken(), kuaishouQrStartVO.getQrLoginSignature(), kuaishouUserVO.getUserId());
                        System.out.println(threadHttpClientEntity.getResult());
                        kuaishouAcceptVO = mapper.readValue(threadHttpClientEntity.getResult(), KuaishouAcceptVO.class);
                        if (kuaishouAcceptVO.getResult() == 1) {
                            Map<String, Object> loginStatusMap = new HashMap<String, Object>();
                            loginStatusMap.put("status", 3);
                            loginStatusMap.put("msg", "授权登陆成功");
                            redisUtil.set(taskId, loginStatusMap, 60000);
                        } else {
                            Map<String, Object> loginStatusMap = new HashMap<String, Object>();
                            loginStatusMap.put("status", -101);
                            loginStatusMap.put("msg", "二维码已过期，请重新获取");
                            redisUtil.set(taskId, loginStatusMap, 60000);
                            return;
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        Map<String, Object> loginStatusMap = new HashMap<String, Object>();
                        loginStatusMap.put("status", -100);
                        loginStatusMap.put("msg", "服务异常,请重新获取二维码");
                        redisUtil.set(taskId, loginStatusMap, 60000);
                        return;
                    }
                    try {
                        threadHttpClientEntity = kuaishouQrCallback(threadHttpClientEntity, kuaishouAcceptVO.getQrToken());
                        System.out.println(threadHttpClientEntity.getResult());
                        JsonNode jsonNode = mapper.readTree(threadHttpClientEntity.getResult());
                        String at = jsonNode.get("kuaishou.live.web.at").asText();
                        threadHttpClientEntity.setUrl("https://live.kuaishou.com/graphql");
                        threadHttpClientEntity = httpClientUtils.callingGraph(threadHttpClientEntity, userLogin(at));
                        System.out.println(threadHttpClientEntity.getResult());
                        threadHttpClientEntity = httpClientUtils.callingGraph(threadHttpClientEntity, userInfoQuery());
                        System.out.println(threadHttpClientEntity.getResult());
                        KuaishouUserCookie kuaishouUserCookie = new KuaishouUserCookie();
                        kuaishouUserCookie.setCookie(new Gson().toJson(threadHttpClientEntity.getCookieStore()));
                        kuaishouUserCookie.setKsid(String.valueOf(kuaishouUserVO.getUserId()));
                        kuaishouUserCookie.setEid(kuaishouUserVO.getEid());
                        kuaishouUserCookie.setUserName(kuaishouUserVO.getUserName());
                        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//                        if(user == null){
//                            user = new LoginUser();
//                            user.setId("xxa");
//                        }
                        kuaishouUserCookie.setUserId(user.getId());
                        kuaishouUserCookieService.saveOrUpdate(kuaishouUserCookie);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }
            };
            thread.start();
            Map<String, Object> loginStatusMap = new HashMap<String, Object>();
            loginStatusMap.put("status", 1);
            loginStatusMap.put("msg", "请使用快手APP扫描二维码");
            redisUtil.set(taskId, loginStatusMap, 60000);
            System.out.println(kuaishouQrStartVO.getImageData());
            return kuaishouQrStartVO.getImageData();
        } else {
            throw new Exception();
        }
    }

    public Map<String, Object> loginStatus(String taskId) {
        Map<String, Object> loginStatusMap = (Map<String, Object>) redisUtil.get(taskId);
        return loginStatusMap;
    }

    public void test() {
        try {

//            String r = i.liveQRLogin();
//            ObjectMapper mapper = new ObjectMapper();
//            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
//            JsonNode resultNode = mapper.readTree(r);
//            Long expireTime = resultNode.get("expireTime").asLong();
//            Integer result = resultNode.get("result").asInt();
//            String qrLoginSignature = resultNode.get("qrLoginSignature").asText();
//            String imageData = resultNode.get("imageData").asText();
//            String callback = resultNode.get("callback").asText();
//            String qrLoginToken = resultNode.get("qrLoginToken").asText();
//            String sid = resultNode.get("sid").asText();
//            Date expireDate = new Date(expireTime);
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//            String expire = sdf.format(expireDate);
//            System.out.println(expire);
//            System.out.println("data:image/png;base64,"+imageData);
//            while (true){
//                i.scanResult(qrLoginToken,qrLoginSignature);
//                Thread.sleep(3000);
//            }


//            HttpClientUtils httpClientUtils = new HttpClientUtils();
//            Map<String,Object> params = new HashMap<String,Object>();
//            Map<String,String> headers = new HashMap<String,String>();
//            params.put("sid","kuaishou.live.web");
//            headers.put("User-Agent","Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0");
//            headers.put("Accept","application/json, text/plain, */*");
//            headers.put("Accept-Language","zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2");
//            headers.put("Accept-Encoding","gzip, deflate, br");
//            headers.put("Referer","https://live.kuaishou.com/");
//            headers.put("Content-Type","application/x-www-form-urlencoded");
//            headers.put("Origin","https://live.kuaishou.com");
//            headers.put("Connection","keep-alive");
//            headers.put("Cookie","did=web_064a1df2953c429a9770308d73d42bdb; didv=1566549687000; clientid=3; client_key=65890b29; Hm_lvt_86a27b7db2c5c0ae37fee4a8a35033ee=1568871207,1569462190");
//            HttpClientEntity httpClientEntity = new HttpClientEntity();
//
//            httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
//            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
//            httpClientEntity.setResult("");
//            httpClientEntity.setHeaders(headers);
//            httpClientEntity.setParams(params);
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.userLogin(""));
//            System.out.println(httpClientEntity.getResult());
//
//            httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/start");
//            httpClientEntity.setHeaders(headers);
//            httpClientEntity.setParams(params);
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            String r = httpClientEntity.getResult();
//            ObjectMapper mapper = new ObjectMapper();
//            JsonNode resultNode = mapper.readTree(r);
//            String imageData = resultNode.get("imageData").asText();
//            String qrLoginSignature = resultNode.get("qrLoginSignature").asText();
//            String qrLoginToken = resultNode.get("qrLoginToken").asText();
//            String sid = resultNode.get("sid").asText();
//            System.out.println("data:image/png;base64,"+imageData);
//            params.put("qrLoginSignature",qrLoginSignature);
//            params.put("qrLoginToken",qrLoginToken);
//            httpClientEntity.setParams(params);
//            httpClientEntity.setResult("");
//            httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/scanResult");
//            Long expireTime = resultNode.get("expireTime").asLong();
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            resultNode = mapper.readTree(httpClientEntity.getResult());
//            Integer result = resultNode.get("result").asInt();
////{"result":1,"user":{"user_id":1153842485,"headurl":"https://tx2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","user_sex":"M","eid":"3x6wv7iyb8pzjty","headurls":[{"cdn":"tx2.a.yximgs.com","url":"https://tx2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg"},{"cdn":"js2.a.yximgs.com","url":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","urlPattern":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg@base@tag%3DimgScale%26r%3D0%26q%3D85%26w%3D{w}%26h%3D{h}%26rotate"}],"user_name":"许祚云"}}
//            httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/acceptResult");
//            params.put("sid","kuaishou.live.web");
//            httpClientEntity.setParams(params);
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            resultNode = mapper.readTree(httpClientEntity.getResult());
//            //{"result":1,"qrToken":"ChRrdWFpc2hvdS5xci5sb2dpbi5hdBKAAQyhyjr5zjzM5arMAn37OS9_D4RlQ_pHR1ahT0MtLjiJhM1VhJSLeRYgfdqd_LQqQmqa3pB_4x1_DSegGX-JA_WwRK2HO0z9OLq8yfOanMjyo0LCumaDx7YQi3o2eJ6upf9DV3rVkOLBNcVeNDolt0K_dMWENZ_ryIHFxJOin54KGhKqdaZmQf5LFLbR_OVeuq10UAQiIECy1gs6CK0aLVawY7EqgvJ5F2PQxkW_cYSJOfH-U_tkKAUwAQ","callback":null,"sid":"kuaishou.live.web"}
//            httpClientEntity.setUrl("https://id.kuaishou.com/pass/kuaishou/login/qr/callback");
//            String qrToken = resultNode.get("qrToken").asText();
//            params.put("qrToken",qrToken);
//            httpClientEntity.setParams(params);
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            resultNode = mapper.readTree(httpClientEntity.getResult());
//            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.userLogin(resultNode.get("kuaishou.live.web.at").asText()));
//            System.out.println(httpClientEntity.getResult());
////{"data":{"login":{"result":1,"__typename":"Response"}}}
//            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.userInfoQuery());
//            System.out.println(httpClientEntity.getResult());
//            //{"data":{"kshellBalance":{"kshell":0,"__typename":"KshellBalance"},"ownerInfo":{"id":"xuzuoyun","principalId":"xuzuoyun","kwaiId":"xuzuoyun","eid":"3x6wv7iyb8pzjty","userId":"1153842485","profile":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","name":"许祚云","description":"","sex":"M","constellation":"","cityName":"北京 石景山区","following":1,"living":false,"watchingCount":null,"isNew":false,"privacy":false,"timestamp":1569573002664,"feeds":null,"verifiedStatus":{"verified":false,"description":"","type":0,"new":false,"__typename":"VerifiedStatus"},"countsInfo":{"fan":"ꯋ","follow":"쾺","photo":"뷊","liked":"첪","open":"뷊","playback":"0","private":"곚","__typename":"CountsInfo"},"bannedStatus":{"banned":false,"defriend":false,"isolate":false,"socialBanned":false,"__typename":"BannedStatus"},"__typename":"User"}}}
//            i.getVedioList("xuzuoyun","","",0);
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.commentListQuery("3x4idgu3eskgmni",1));
//            System.out.println(httpClientEntity.getResult());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        try {
            KuaishouWebInterfaceServiceImpl i = new KuaishouWebInterfaceServiceImpl();
            i.getCST("Oct 8, 2020 11:07:17 AM");
//            KuaishouQrStartVO kuaishouQrStartVO = i.kuaishouQrStart();
//            System.out.println(kuaishouQrStartVO.getResult());
//
//            i.kuaishouQrScanResult(kuaishouQrStartVO.getQrLoginToken(),kuaishouQrStartVO.getQrLoginSignature(),kuaishouQrStartVO.getRequestId());
//            System.out.println("扫码成功");
//            i.kuaishouQrAcceptResult(kuaishouQrStartVO.getQrLoginToken(),kuaishouQrStartVO.getQrLoginSignature(),kuaishouQrStartVO.getRequestId());
//            System.out.println("登陆成功");
//            String r = i.liveQRLogin();
//            ObjectMapper mapper = new ObjectMapper();
//            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
//            JsonNode resultNode = mapper.readTree(r);
//            Long expireTime = resultNode.get("expireTime").asLong();
//            Integer result = resultNode.get("result").asInt();
//            String qrLoginSignature = resultNode.get("qrLoginSignature").asText();
//            String imageData = resultNode.get("imageData").asText();
//            String callback = resultNode.get("callback").asText();
//            String qrLoginToken = resultNode.get("qrLoginToken").asText();
//            String sid = resultNode.get("sid").asText();
//            Date expireDate = new Date(expireTime);
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//            String expire = sdf.format(expireDate);
//            System.out.println(expire);
//            System.out.println("data:image/png;base64,"+imageData);
//            while (true){
//                i.scanResult(qrLoginToken,qrLoginSignature);
//                Thread.sleep(3000);
//            }


//            HttpClientUtils httpClientUtils = new HttpClientUtils();
//            Map<String,Object> params = new HashMap<String,Object>();
//            Map<String,String> headers = new HashMap<String,String>();
//            params.put("sid","kuaishou.live.web");
//            headers.put("User-Agent","Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0");
//            headers.put("Accept","application/json, text/plain, */*");
//            headers.put("Accept-Language","zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2");
//            headers.put("Accept-Encoding","gzip, deflate, br");
//            headers.put("Referer","https://live.kuaishou.com/");
//            headers.put("Content-Type","application/x-www-form-urlencoded");
//            headers.put("Origin","https://live.kuaishou.com");
//            headers.put("Connection","keep-alive");
//            headers.put("Cookie","did=web_064a1df2953c429a9770308d73d42bdb; didv=1566549687000; clientid=3; client_key=65890b29; Hm_lvt_86a27b7db2c5c0ae37fee4a8a35033ee=1568871207,1569462190");
//            HttpClientEntity httpClientEntity = new HttpClientEntity();
//
//            httpClientEntity.setCloseableHttpClient(httpClientUtils.createSSLClientDefault());
//            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
//            httpClientEntity.setResult("");
//            httpClientEntity.setHeaders(headers);
//            httpClientEntity.setParams(params);
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.userLogin(""));
//            System.out.println(httpClientEntity.getResult());
//
//            httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/start");
//            httpClientEntity.setHeaders(headers);
//            httpClientEntity.setParams(params);
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            String r = httpClientEntity.getResult();
//            ObjectMapper mapper = new ObjectMapper();
//            JsonNode resultNode = mapper.readTree(r);
//            String imageData = resultNode.get("imageData").asText();
//            String qrLoginSignature = resultNode.get("qrLoginSignature").asText();
//            String qrLoginToken = resultNode.get("qrLoginToken").asText();
//            String sid = resultNode.get("sid").asText();
//            System.out.println("data:image/png;base64,"+imageData);
//            params.put("qrLoginSignature",qrLoginSignature);
//            params.put("qrLoginToken",qrLoginToken);
//            httpClientEntity.setParams(params);
//            httpClientEntity.setResult("");
//            httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/scanResult");
//            Long expireTime = resultNode.get("expireTime").asLong();
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            resultNode = mapper.readTree(httpClientEntity.getResult());
//            Integer result = resultNode.get("result").asInt();
////{"result":1,"user":{"user_id":1153842485,"headurl":"https://tx2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","user_sex":"M","eid":"3x6wv7iyb8pzjty","headurls":[{"cdn":"tx2.a.yximgs.com","url":"https://tx2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg"},{"cdn":"js2.a.yximgs.com","url":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","urlPattern":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg@base@tag%3DimgScale%26r%3D0%26q%3D85%26w%3D{w}%26h%3D{h}%26rotate"}],"user_name":"许祚云"}}
//            httpClientEntity.setUrl("https://id.kuaishou.com/rest/c/infra/ks/qr/acceptResult");
//            params.put("sid","kuaishou.live.web");
//            httpClientEntity.setParams(params);
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            resultNode = mapper.readTree(httpClientEntity.getResult());
//            //{"result":1,"qrToken":"ChRrdWFpc2hvdS5xci5sb2dpbi5hdBKAAQyhyjr5zjzM5arMAn37OS9_D4RlQ_pHR1ahT0MtLjiJhM1VhJSLeRYgfdqd_LQqQmqa3pB_4x1_DSegGX-JA_WwRK2HO0z9OLq8yfOanMjyo0LCumaDx7YQi3o2eJ6upf9DV3rVkOLBNcVeNDolt0K_dMWENZ_ryIHFxJOin54KGhKqdaZmQf5LFLbR_OVeuq10UAQiIECy1gs6CK0aLVawY7EqgvJ5F2PQxkW_cYSJOfH-U_tkKAUwAQ","callback":null,"sid":"kuaishou.live.web"}
//            httpClientEntity.setUrl("https://id.kuaishou.com/pass/kuaishou/login/qr/callback");
//            String qrToken = resultNode.get("qrToken").asText();
//            params.put("qrToken",qrToken);
//            httpClientEntity.setParams(params);
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.httpPostParamRequest(httpClientEntity);
//            System.out.println(httpClientEntity.getResult());
//            resultNode = mapper.readTree(httpClientEntity.getResult());
//            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.userLogin(resultNode.get("kuaishou.live.web.at").asText()));
//            System.out.println(httpClientEntity.getResult());
////{"data":{"login":{"result":1,"__typename":"Response"}}}
//            httpClientEntity.setUrl("https://live.kuaishou.com/graphql");
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.userInfoQuery());
//            System.out.println(httpClientEntity.getResult());
//            //{"data":{"kshellBalance":{"kshell":0,"__typename":"KshellBalance"},"ownerInfo":{"id":"xuzuoyun","principalId":"xuzuoyun","kwaiId":"xuzuoyun","eid":"3x6wv7iyb8pzjty","userId":"1153842485","profile":"https://js2.a.yximgs.com/uhead/AB/2018/11/30/19/BMjAxODExMzAxOTU5MDNfMTE1Mzg0MjQ4NV8yX2hkNTc4Xzk2Mg==_s.jpg","name":"许祚云","description":"","sex":"M","constellation":"","cityName":"北京 石景山区","following":1,"living":false,"watchingCount":null,"isNew":false,"privacy":false,"timestamp":1569573002664,"feeds":null,"verifiedStatus":{"verified":false,"description":"","type":0,"new":false,"__typename":"VerifiedStatus"},"countsInfo":{"fan":"ꯋ","follow":"쾺","photo":"뷊","liked":"첪","open":"뷊","playback":"0","private":"곚","__typename":"CountsInfo"},"bannedStatus":{"banned":false,"defriend":false,"isolate":false,"socialBanned":false,"__typename":"BannedStatus"},"__typename":"User"}}}
//            i.getVedioList("xuzuoyun","","",0);
//            httpClientEntity.setResult("");
//            httpClientEntity = httpClientUtils.callingGraph(httpClientEntity,i.commentListQuery("3x4idgu3eskgmni",1));
//            System.out.println(httpClientEntity.getResult());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
